Candy - Leetcode 135 - Python

Поділитися
Вставка
  • Опубліковано 16 гру 2024

КОМЕНТАРІ • 71

  • @LeeK301
    @LeeK301 8 місяців тому +40

    One way I try to challenge myself when solving these problems:
    If I can't solve intitally and I am just stuck, come to NeetCode's videos and watch the intuition portion. If I feel like I have a good idea of what he's talking about, I will pause the video and attempt to solve again under a time limit. If I can't solve it again, I will come back to his vid and watch for the solution as well.

    • @RhoBustDev
      @RhoBustDev 2 місяці тому +1

      appreciate it, its the same for me :)

  • @adamlin2301
    @adamlin2301 9 місяців тому +10

    And this is how your boss think of giving salary to you

  • @victortruong2538
    @victortruong2538 Рік тому +19

    Oh I was waiting for you :) yes the problem is poorly worded I feel

  • @JasonAhn-u5u
    @JasonAhn-u5u Рік тому +6

    I only thought about iterating through left -> right..always amazing

  • @0brooo
    @0brooo 7 місяців тому +5

    THIS is a valid solution to this problem.
    I was looking at the solutions with the most upvotes, and their solution was to mathematically solve it by adding up all the longest increasing subarray and decreasing subarray, and then subtracting the lowest of the two from the totalCandy. I hate that leetcode solutions have become mathematically solutions rather than programming. Solutions for the CarFleet problem is a hashmap with the key being the product of a formula. Then returning all the unique keys. Like what is that, the solution should go through a process that imitates the problem. Now we’re seeing problems that are purely solved by inventing a formula for the specific issue. Rather than preparing you for problems you’ll face regularly

  • @VarunMittal-viralmutant
    @VarunMittal-viralmutant 3 місяці тому +2

    An alternate to the last step:
    if ratings[i] > ratings[i+1]:
    arr[i] = max(arr[i], arr[i+1]+1)
    That was more intuitive for me:
    if ratings[i] > ratings[i+1] and arr[i]

  • @HR-pz7ts
    @HR-pz7ts 8 місяців тому +1

    Thanks man you're so good that I never had to wait for you to code.

  • @HtotheG
    @HtotheG Рік тому +6

    I came up with the O(n^2) solution with a while loop of while(candyIncreasedThisLoop){ do a pass and add 1 if the rules arent followed for each } and I was proud of myself, but damn this code is not only neat is damn near beautiful 😢 Thank you for the great explanation as always you are a huge help in my career journey as a new grad at the moment. I can't thank you enough for your years of backlogs of coding solutions I am learning from right now. Keep up the amazing work!

  • @GuruPrasadShukla
    @GuruPrasadShukla Рік тому +6

    very well explained!
    just like interview style!

  • @schrodingerskatt222
    @schrodingerskatt222 Рік тому +2

    Amazing explanation !!!!. Greedy Questions are just mind blowing.

    • @AyushSharma-ux4fk
      @AyushSharma-ux4fk Рік тому +1

      Yea, greedy hits you up as if you never know what has happened.

  • @dineshkumarkb1372
    @dineshkumarkb1372 Рік тому

    Thanks for uploading this. I had requested for this in the comments in one of your videos.

  • @CognitiveAnkit
    @CognitiveAnkit 11 місяців тому

    You are totally more than awesome
    You explained this concept in such an awesome manner I have no words for it

  • @hannibalm090009
    @hannibalm090009 Рік тому

    Thanks a lot bro, I actually just solved it had to pause the video at the mid of the intuition because that was the missing part that I needed, went and solved it then got back.

  • @abdelrahmanashraf1510
    @abdelrahmanashraf1510 Рік тому +5

    You mentioned that no extra memory is needed, yet your solution clearly allocated a new array to track the number of candies given. Doesn't that make the space complexity O(n)?

    • @NeetCodeIO
      @NeetCodeIO  Рік тому +7

      Yep, that's my bad. Space is O(n)

    • @abdelrahmanashraf1510
      @abdelrahmanashraf1510 Рік тому

      @@NeetCodeIO Thanks for clarifying! appreciate your efforts and explanations 👍🏼

  • @iCodeStuff69
    @iCodeStuff69 10 місяців тому

    Quite much easier problem than lots of "easy" ones.

  • @joey_zhu
    @joey_zhu 8 місяців тому

    I derived my solution by going deep into the diffs array and trying to reduce it to other problems, my soln ended up going to 30+ lines so i was quite disappointed to go into the solutions and see that ppl had done it in like 10 lines

  • @stith_pragya
    @stith_pragya Рік тому +1

    Thank You So Much for this wonderful video...🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @socialbeing5591
    @socialbeing5591 8 місяців тому

    literally the best explaination

  • @CodeWithRVR
    @CodeWithRVR Рік тому +2

    Wait is over guys 😅

  • @jaishriharivishnu
    @jaishriharivishnu 6 місяців тому

    how you get so good at logic, damn nice and nice , best approach

  • @deepakjain248
    @deepakjain248 10 місяців тому +1

    isn't it O(n) space solution as we are using extra array to store candies ?

  • @CodeSuccessChronicle
    @CodeSuccessChronicle 7 місяців тому

    Best Explanation 👏🏻 Nice work great intution

  • @mahinhossen4251
    @mahinhossen4251 10 місяців тому +1

    I have seen a 0(1) space solution in lc solution section. Could u explain it in a future vid

  • @krateskim4169
    @krateskim4169 Рік тому +1

    was waiting for this

  • @aadityakiran_s
    @aadityakiran_s 10 місяців тому

    11:52 precisely. Did you make that same mistake there?

  • @ishaqniloy1532
    @ishaqniloy1532 Рік тому

    Finally solved the problem. Thank you so much!

    • @RishabhSingh-xn3xu
      @RishabhSingh-xn3xu Рік тому

      solve on your own,give your everything to solve the problem

    • @pixelup4929
      @pixelup4929 8 місяців тому

      @@RishabhSingh-xn3xu 🤣

  • @VidyaBhandary
    @VidyaBhandary Рік тому +1

    Genius explanation... Wow

  • @elizabethr5161
    @elizabethr5161 9 місяців тому

    Best explanation ever

  • @Meridian-lk2fo
    @Meridian-lk2fo Рік тому +1

    First LC hard I solved on my own! :)

  • @FUNTasticFlutter
    @FUNTasticFlutter 8 місяців тому

    good job man. very helpful series......

  • @aditya-lr2in
    @aditya-lr2in Рік тому

    Was waiting for this :)

  • @truongtran99_
    @truongtran99_ 8 місяців тому

    You're a genius

  • @omdandade8245
    @omdandade8245 Рік тому

    I missed that "welocme back" this morning...

  • @Manishgupta200
    @Manishgupta200 9 місяців тому

    Great explaination ❤

  • @aisteelmemesforaliving
    @aisteelmemesforaliving Рік тому +3

    Seems like this problem can be solved in one pass too, but I have a hard time understanding that lol. Would've been nice if you could explain the onepass method because I can understand your explanations only. Others take way too much time drawing, or do a poor job of explaining.

    • @aisteelmemesforaliving
      @aisteelmemesforaliving Рік тому +1

      ​@@Stay_away_from_my_swamp_waterno, apparently, you can use three variables up, down and peak and then do something which I don't understand to complete this in one pass and O(1) space complexity. It's the top solution on solutions page (by vanAmsen). I don't think I can post links here, the spam filter will probably go off.

    • @stefanopalmieri9201
      @stefanopalmieri9201 Рік тому

      @@aisteelmemesforaliving I'm also looking for a better explanation of that algorithm. If I figure it out, I'll make a video.

    • @aisteelmemesforaliving
      @aisteelmemesforaliving Рік тому

      @@stefanopalmieri9201 please don't forget to reply to this if you actually do. Highly appreciated.

    • @stefanopalmieri9201
      @stefanopalmieri9201 Рік тому

      @@aisteelmemesforaliving It's uploaded now: ua-cam.com/video/_l9N_LcplLs/v-deo.html

    • @himanshu6489
      @himanshu6489 9 місяців тому

      any luck?@@aisteelmemesforaliving

  • @ahamedsha9688
    @ahamedsha9688 Рік тому

    the problem is not enough described in leetcode
    12:08 stuck 2 days because i did not take that into account

  • @becomingbesthackerprogramm4644

    How to get referrals brother, I worked really hard , solved 500+ problems on leetcode but still I m suffering to get interviews

  • @apoorvasingh5702
    @apoorvasingh5702 8 місяців тому

    Well explained 👍

  • @satwiktatikonda764
    @satwiktatikonda764 Рік тому

    this one looks easy after seeing solution ,but how to endup with this intuition !!!

  • @uptwist2260
    @uptwist2260 Рік тому

    Thanks for the daily

  • @suniln9029
    @suniln9029 11 місяців тому

    Can you explain one pass approach?

  • @chinni469
    @chinni469 Місяць тому

    This was asked to me in an interview and of course, I messed it up😭

  • @piglovesasy
    @piglovesasy 11 днів тому

    very clever

  • @hwval-zw4hy
    @hwval-zw4hy 10 місяців тому

    It's O(n) additional memory, isn't it?

  • @stefanopalmieri9201
    @stefanopalmieri9201 Рік тому

    This is an O(N) space solution but a O(1) space solution does exist for this problem.

  • @mohithadiyal6083
    @mohithadiyal6083 Рік тому

    The best

  • @Antinormanisto
    @Antinormanisto 9 місяців тому +1

    How i can get big brain like your?

  • @CS_n00b
    @CS_n00b 8 місяців тому

    I have no idea how I could figure this out on my own tbh

  • @hwang1607
    @hwang1607 5 місяців тому

    Now do it using O(1) space

  • @PriyaSharma-z5e3o
    @PriyaSharma-z5e3o 2 місяці тому

    Corporate in a nutshell

  • @langacristian8366
    @langacristian8366 8 місяців тому

    im too dumb for this shit chief

  • @pryshrng
    @pryshrng Рік тому +1

    not pertaining to the question or this video, but what's the difference between this channel and the original channel? @neetcode